<?php
/***************************************************************************
 *						def_userfields.php
 *						------------------
 *	begin			: 03/10/2003
 *	copyright		: Ptirhiik
 *	email			: admin@rpgnet-fr.com
 *
 *	version			: 1.0.2 - 17/10/2003
 *
 *	last update		: 2005-08-07 15:24:31 by ednique *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die('Hacking attempt');
	exit;
}

//--------------------------------------------------------------------------------------------------
//
// tables_linked array
//
//		key = identifier (used in [*])
//
//			sql_id		: id used in sql request,
//			sql_join	: sql FROM statement
//			sql_where	: WHERE statement
//			sql_order	: ORDER BY statement
//
//--------------------------------------------------------------------------------------------------
$tables_linked = array(
		'BUDDY_MY' => array(
				'sql_id' => 'i',
				'sql_join' => 'LEFT JOIN [cst.BUDDYS_TABLE] AS [BUDDY_MY] ON [BUDDY_MY].user_id=[view.user_id] AND [BUDDY_MY].buddy_id=[USERS].user_id',
			),
		'FLAGS' => array(
				'sql_id' => 'f',
				'sql_join' => 'LEFT JOIN [cst.FLAGS_TABLE] AS [FLAGS].flag_image = [USERS].user_flag',
				'sql_where' => '[USERS].user_id <> ANONYMOUS',
			),
		'BUDDY_OF' => array(
				'sql_id' => 'b',
				'sql_join' => 'LEFT JOIN [cst.BUDDYS_TABLE] AS [BUDDY_OF] ON [BUDDY_OF].user_id=[USERS].user_id AND [BUDDY_OF].buddy_id=[view.user_id]',
			),
		'CUSTOM_RANKS' => array(
				'sql_id' => 'cr',
				'sql_join' => 'LEFT JOIN [cst.RANKS_TABLE] AS [CUSTOM_RANKS] ON ([RANKS].rank_id = [USERS].user_custom_rank AND [RANKS].rank_special <> 0)',
				'sql_where' => '',
				'sql_order' => '',
			),
		'RANKS' => array(
				'sql_id' => 'r',
				'sql_join' => 'LEFT JOIN [cst.RANKS_TABLE] AS [RANKS] ON ([USERS].user_rank > 0 AND [RANKS].rank_special <> 0 AND [RANKS].rank_id = [USERS].user_rank) OR ([USERS].user_rank = 0 AND [RANKS].rank_special = 0 AND [USERS].user_posts >= [RANKS].rank_min AND [USERS].user_posts < [RANKS].rank_max)',
			),
		'RANKS_SPECIAL' => array(
				'sql_id' => 'rs',
				'sql_join' => '[cst.RANKS_TABLE] AS [RANKS_SPECIAL]',
				'sql_where' => '[RANKS_SPECIAL].rank_special = 1',
				'sql_order' => '[RANKS_SPECIAL].rank_title',
			),
		'THEMES_TABLE' => array(
				'sql_id' => 'th',
				'sql_join' => '[cst.THEMES_TABLE] AS [THEMES_TABLE]',
				'sql_order' => '[THEMES_TABLE].style_name, [THEMES_TABLE].themes_id',
			),
		'USERS' => array(
				'sql_id' => 'u',
				'sql_join' => '[cst.USERS_TABLE] AS [USERS]',
			),
	);

//--------------------------------------------------------------------------------------------------
//
// $values_list array
//
//		key = values list name
//			func	= special function
//			table	= use tables to build the list
//				main	: main table the list is based on,
//				key		: key field,
//				txt		: text field,
//				img		: image field
//			values	= field values
//				txt		: text or $lang key entry to display
//				img		: img url or $images key entry to display
//--------------------------------------------------------------------------------------------------
$values_list = array(
		'list_auth' => array(
				'func' => 'get_auth_list',
							),
		'list_cal_search' => array(
								'values' => array(
						'POSTS' => array('txt' => 'mini_cal_search_posts', 'img' => ''),
						'EVENTS' => array('txt' => 'mini_cal_search_events', 'img' => ''),
					),
			),
		'list_cal_versions' => array(
								'values' => array(
						'NONE' => array('txt' => 'mini_cal_version_none', 'img' => ''),
						'MYCAL' => array('txt' => 'mini_cal_version_mycal', 'img' => ''),
						'PLUS' => array('txt' => 'mini_cal_version_plus', 'img' => ''),
						'TOPIC' => array('txt' => 'mini_cal_version_topic', 'img' => ''),
						'SNAIL' => array('txt' => 'mini_cal_version_snail', 'img' => ''),
						'SNAILLITE' => array('txt' => 'mini_cal_version_snaillite', 'img' => ''),
					),
			),
		'list_country' => array(
								'values' => array(
						0 => array('txt' => 'None', 'img' => 'blank'),
						1 => array('txt' => 'Afghanistan', 'img' => 'afghanistan'),
						2 => array('txt' => 'Albania', 'img' => 'albania'),
						3 => array('txt' => 'Algeria', 'img' => 'algeria'),
						4 => array('txt' => 'Andorra', 'img' => 'andorra'),
						5 => array('txt' => 'Angola', 'img' => 'angola'),
						6 => array('txt' => 'Antigua and Barbuda', 'img' => 'antiguaandbarbuda'),
						7 => array('txt' => 'Argentina', 'img' => 'argentina'),
						8 => array('txt' => 'Armenia', 'img' => 'armenia'),
						9 => array('txt' => 'Australia', 'img' => 'australia'),
						10 => array('txt' => 'Austria', 'img' => 'austria'),
						11 => array('txt' => 'Azerbaijan', 'img' => 'azerbaijan'),
						12 => array('txt' => 'Bahamas', 'img' => 'bahamas'),
						13 => array('txt' => 'Bahrain', 'img' => 'bahrain'),
						14 => array('txt' => 'Bangladesh', 'img' => 'bangladesh'),
						15 => array('txt' => 'Barbados', 'img' => 'barbados'),
						16 => array('txt' => 'Belarus', 'img' => 'belarus'),
						17 => array('txt' => 'Belgium', 'img' => 'belgium'),
						18 => array('txt' => 'Belize', 'img' => 'belize'),
						19 => array('txt' => 'Benin', 'img' => 'benin'),
						20 => array('txt' => 'Bhutan', 'img' => 'bhutan'),
						21 => array('txt' => 'Bolivia', 'img' => 'bolivia'),
						22 => array('txt' => 'Bosnia Herzegovina', 'img' => 'bosnia_herzegovina'),
						23 => array('txt' => 'Botswana', 'img' => 'botswana'),
						24 => array('txt' => 'Brazil', 'img' => 'brazil'),
						25 => array('txt' => 'Brunei', 'img' => 'brunei'),
						26 => array('txt' => 'Bulgaria', 'img' => 'bulgaria'),
						27 => array('txt' => 'Burkinafaso', 'img' => 'burkinafaso'),
						28 => array('txt' => 'Burma', 'img' => 'burma'),
						29 => array('txt' => 'Burundi', 'img' => 'burundi'),
						30 => array('txt' => 'Cambodia', 'img' => 'cambodia'),
						31 => array('txt' => 'Cameroon', 'img' => 'cameroon'),
						32 => array('txt' => 'Canada', 'img' => 'canada'),
						33 => array('txt' => 'Central African Rep', 'img' => 'centralafricanrep'),
						34 => array('txt' => 'Chad', 'img' => 'chad'),
						35 => array('txt' => 'Chile', 'img' => 'chile'),
						36 => array('txt' => 'China', 'img' => 'china'),
						37 => array('txt' => 'Columbia', 'img' => 'columbia'),
						38 => array('txt' => 'Comoros', 'img' => 'comoros'),
						39 => array('txt' => 'Congo', 'img' => 'congo'),
						40 => array('txt' => 'Costarica', 'img' => 'costarica'),
						41 => array('txt' => 'Croatia', 'img' => 'croatia'),
						42 => array('txt' => 'Cuba', 'img' => 'cuba'),
						43 => array('txt' => 'Cyprus', 'img' => 'cyprus'),
						44 => array('txt' => 'Czech Republic', 'img' => 'czechrepublic'),
						45 => array('txt' => 'Demrepcongo', 'img' => 'demrepcongo'),
						46 => array('txt' => 'Denmark', 'img' => 'denmark'),
						47 => array('txt' => 'Djibouti', 'img' => 'djibouti'),
						48 => array('txt' => 'Dominica', 'img' => 'dominica'),
						49 => array('txt' => 'Dominican Rep', 'img' => 'dominicanrep'),
						50 => array('txt' => 'Ecuador', 'img' => 'ecuador'),
						51 => array('txt' => 'Egypt', 'img' => 'egypt'),
						52 => array('txt' => 'Elsalvador', 'img' => 'elsalvador'),
						53 => array('txt' => 'Eq Guinea', 'img' => 'eq_guinea'),
						54 => array('txt' => 'Eritrea', 'img' => 'eritrea'),
						55 => array('txt' => 'Estonia', 'img' => 'estonia'),
						56 => array('txt' => 'Ethiopia', 'img' => 'ethiopia'),
						57 => array('txt' => 'Fiji', 'img' => 'fiji'),
						58 => array('txt' => 'Finland', 'img' => 'finland'),
						59 => array('txt' => 'France', 'img' => 'france'),
						60 => array('txt' => 'Gabon', 'img' => 'gabon'),
						61 => array('txt' => 'Gambia', 'img' => 'gambia'),
						62 => array('txt' => 'Germany', 'img' => 'germany'),
						63 => array('txt' => 'Ghana', 'img' => 'ghana'),
						64 => array('txt' => 'Greece', 'img' => 'greece'),
						65 => array('txt' => 'Grenada', 'img' => 'grenada'),
						66 => array('txt' => 'Grenadines', 'img' => 'grenadines'),
						67 => array('txt' => 'Guatemala', 'img' => 'guatemala'),
						68 => array('txt' => 'Guinea', 'img' => 'guinea'),
						69 => array('txt' => 'Guineabissau', 'img' => 'guineabissau'),
						70 => array('txt' => 'Guyana', 'img' => 'guyana'),
						71 => array('txt' => 'Haiti', 'img' => 'haiti'),
						72 => array('txt' => 'Honduras', 'img' => 'honduras'),
						73 => array('txt' => 'Hong Kong', 'img' => 'hong kong'),
						74 => array('txt' => 'Hungary', 'img' => 'hungary'),
						75 => array('txt' => 'Iceland', 'img' => 'iceland'),
						76 => array('txt' => 'India', 'img' => 'india'),
						77 => array('txt' => 'Indonesia', 'img' => 'indonesia'),
						78 => array('txt' => 'Iran', 'img' => 'iran'),
						79 => array('txt' => 'Iraq', 'img' => 'iraq'),
						80 => array('txt' => 'Ireland', 'img' => 'ireland'),
						81 => array('txt' => 'Israel', 'img' => 'israel'),
						82 => array('txt' => 'Italy', 'img' => 'italy'),
						83 => array('txt' => 'Ivory Coast', 'img' => 'ivorycoast'),
						84 => array('txt' => 'Jamaica', 'img' => 'jamaica'),
						85 => array('txt' => 'Japan', 'img' => 'japan'),
						86 => array('txt' => 'Jordan', 'img' => 'jordan'),
						87 => array('txt' => 'Kazakhstan', 'img' => 'kazakhstan'),
						88 => array('txt' => 'Kenya', 'img' => 'kenya'),
						89 => array('txt' => 'Kiribati', 'img' => 'kiribati'),
						90 => array('txt' => 'Kuwait', 'img' => 'kuwait'),
						91 => array('txt' => 'Kyrgyzstan', 'img' => 'kyrgyzstan'),
						92 => array('txt' => 'Laos', 'img' => 'laos'),
						93 => array('txt' => 'Latvia', 'img' => 'latvia'),
						94 => array('txt' => 'Lebanon', 'img' => 'lebanon'),
						95 => array('txt' => 'Liberia', 'img' => 'liberia'),
						96 => array('txt' => 'Libya', 'img' => 'libya'),
						97 => array('txt' => 'Liechtenstein', 'img' => 'liechtenstein'),
						98 => array('txt' => 'Lithuania', 'img' => 'lithuania'),
						99 => array('txt' => 'Luxembourg', 'img' => 'luxembourg'),
						100 => array('txt' => 'Macadonia', 'img' => 'macadonia'),
						101 => array('txt' => 'Macau', 'img' => 'macau'),
						102 => array('txt' => 'Madagascar', 'img' => 'madagascar'),
						103 => array('txt' => 'Malawi', 'img' => 'malawi'),
						104 => array('txt' => 'Malaysia', 'img' => 'malaysia'),
						105 => array('txt' => 'Maldives', 'img' => 'maldives'),
						106 => array('txt' => 'Mali', 'img' => 'mali'),
						107 => array('txt' => 'Malta', 'img' => 'malta'),
						108 => array('txt' => 'Mauritania', 'img' => 'mauritania'),
						109 => array('txt' => 'Mauritius', 'img' => 'mauritius'),
						110 => array('txt' => 'Mexico', 'img' => 'mexico'),
						111 => array('txt' => 'Micronesia', 'img' => 'micronesia'),
						112 => array('txt' => 'Moldova', 'img' => 'moldova'),
						113 => array('txt' => 'Monaco', 'img' => 'monaco'),
						114 => array('txt' => 'Mongolia', 'img' => 'mongolia'),
						115 => array('txt' => 'Morocco', 'img' => 'morocco'),
						116 => array('txt' => 'Mozambique', 'img' => 'mozambique'),
						117 => array('txt' => 'Namibia', 'img' => 'namibia'),
						118 => array('txt' => 'Nauru', 'img' => 'nauru'),
						119 => array('txt' => 'Nepal', 'img' => 'nepal'),
						120 => array('txt' => 'Neth Antilles', 'img' => 'neth_antilles'),
						121 => array('txt' => 'Netherlands', 'img' => 'netherlands'),
						122 => array('txt' => 'New Zealand', 'img' => 'newzealand'),
						123 => array('txt' => 'Nicaragua', 'img' => 'nicaragua'),
						124 => array('txt' => 'Niger', 'img' => 'niger'),
						125 => array('txt' => 'Nigeria', 'img' => 'nigeria'),
						126 => array('txt' => 'North Korea', 'img' => 'north_korea'),
						127 => array('txt' => 'Norway', 'img' => 'norway'),
						128 => array('txt' => 'Oman', 'img' => 'oman'),
						129 => array('txt' => 'Pakistan', 'img' => 'pakistan'),
						130 => array('txt' => 'Panama', 'img' => 'panama'),
						131 => array('txt' => 'Papua Newguinea', 'img' => 'papuanewguinea'),
						132 => array('txt' => 'Paraguay', 'img' => 'paraguay'),
						133 => array('txt' => 'Peru', 'img' => 'peru'),
						134 => array('txt' => 'Philippines', 'img' => 'philippines'),
						135 => array('txt' => 'Poland', 'img' => 'poland'),
						136 => array('txt' => 'Portugal', 'img' => 'portugal'),
						137 => array('txt' => 'Puertorico', 'img' => 'puertorico'),
						138 => array('txt' => 'Qatar', 'img' => 'qatar'),
						139 => array('txt' => 'Quebec', 'img' => 'quebec'),
						140 => array('txt' => 'Rawanda', 'img' => 'rawanda'),
						141 => array('txt' => 'Romania', 'img' => 'romania'),
						142 => array('txt' => 'Russia', 'img' => 'russia'),
						143 => array('txt' => 'Sao Tome', 'img' => 'sao tome'),
						144 => array('txt' => 'Saudiarabia', 'img' => 'saudiarabia'),
						145 => array('txt' => 'Senegal', 'img' => 'senegal'),
						146 => array('txt' => 'Serbia', 'img' => 'serbia'),
						147 => array('txt' => 'Seychelles', 'img' => 'seychelles'),
						148 => array('txt' => 'Sierraleone', 'img' => 'sierraleone'),
						149 => array('txt' => 'Singapore', 'img' => 'singapore'),
						150 => array('txt' => 'Slovakia', 'img' => 'slovakia'),
						151 => array('txt' => 'Slovenia', 'img' => 'slovenia'),
						152 => array('txt' => 'Solomon Islands', 'img' => 'solomon_islands'),
						153 => array('txt' => 'Somalia', 'img' => 'somalia'),
						154 => array('txt' => 'South Korea', 'img' => 'south_korea'),
						155 => array('txt' => 'South Africa', 'img' => 'southafrica'),
						156 => array('txt' => 'Spain', 'img' => 'spain'),
						157 => array('txt' => 'Srilanka', 'img' => 'srilanka'),
						158 => array('txt' => 'Stkitts Nevis', 'img' => 'stkitts_nevis'),
						159 => array('txt' => 'St Lucia', 'img' => 'stlucia'),
						160 => array('txt' => 'Sudan', 'img' => 'sudan'),
						161 => array('txt' => 'Suriname', 'img' => 'suriname'),
						162 => array('txt' => 'Sweden', 'img' => 'sweden'),
						163 => array('txt' => 'Switzerland', 'img' => 'switzerland'),
						164 => array('txt' => 'Syria', 'img' => 'syria'),
						165 => array('txt' => 'Taiwan', 'img' => 'taiwan'),
						166 => array('txt' => 'Tajikistan', 'img' => 'tajikistan'),
						167 => array('txt' => 'Tanzania', 'img' => 'tanzania'),
						168 => array('txt' => 'Thailand', 'img' => 'thailand'),
						169 => array('txt' => 'Togo', 'img' => 'togo'),
						170 => array('txt' => 'Tonga', 'img' => 'tonga'),
						171 => array('txt' => 'Trinidad and Tobago', 'img' => 'trinidadandtobago'),
						172 => array('txt' => 'Tunisia', 'img' => 'tunisia'),
						173 => array('txt' => 'Turkey', 'img' => 'turkey'),
						174 => array('txt' => 'Turkmenistan', 'img' => 'turkmenistan'),
						175 => array('txt' => 'Tuvala', 'img' => 'tuvala'),
						176 => array('txt' => 'UAE', 'img' => 'uae'),
						177 => array('txt' => 'Uganda', 'img' => 'uganda'),
						178 => array('txt' => 'United Kingdom', 'img' => 'uk'),
						179 => array('txt' => 'Ukraine', 'img' => 'ukraine'),
						180 => array('txt' => 'Uruguay', 'img' => 'uruguay'),
						181 => array('txt' => 'USA', 'img' => 'usa'),
						182 => array('txt' => 'USSR', 'img' => 'ussr'),
						183 => array('txt' => 'Uzbekistan', 'img' => 'uzbekistan'),
						184 => array('txt' => 'Vanuatu', 'img' => 'vanuatu'),
						185 => array('txt' => 'Venezuela', 'img' => 'venezuela'),
						186 => array('txt' => 'Vietnam', 'img' => 'vietnam'),
						187 => array('txt' => 'Western Samoa', 'img' => 'western_samoa'),
						188 => array('txt' => 'Yemen', 'img' => 'yemen'),
						189 => array('txt' => 'Yugoslavia', 'img' => 'yugoslavia'),
						190 => array('txt' => 'Zaire', 'img' => 'zaire'),
						191 => array('txt' => 'Zambia', 'img' => 'zambia'),
						192 => array('txt' => 'Zimbabwe', 'img' => 'zimbabwe'),
					),
			),
		'list_gender' => array(
								'values' => array(
						0 => array('txt' => 'No_gender_specify', 'img' => 'No_gender_specify'),
						1 => array('txt' => 'Male', 'img' => 'Male'),
						2 => array('txt' => 'Female', 'img' => 'Female'),
					),
			),
		'list_sig' => array(
								'values' => array(
						0 => array('txt' => 'No', 'img' => ''),
						1 => array('txt' => 'sig_yes_controled', 'img' => ''),
						2 => array('txt' => 'sig_yes_not_controled', 'img' => ''),
					),
			),
		'list_holidays' => array(
								'values' => array(
						2 => array('txt' => 'No_holidays_specify', 'img' => 'No_holidays_specify'),
						0 => array('txt' => 'No', 'img' => 'No'),
						1 => array('txt' => 'Yes', 'img' => 'Yes'),
					),
			),
		'list_langs' => array(
				'func' => 'get_langs_list',
							),
		'list_groups' => array(
				'func' => 'get_group_list',
							),
		'list_special_ranks' => array(
						'table' => array(
			'main'	=> 'RANKS_SPECIAL',
			'key'	=> '[RANKS_SPECIAL].rank_id',
			'txt'	=> '[RANKS_SPECIAL].rank_title',
			'img'	=> '[RANKS_SPECIAL].rank_image',
		),
						'values' => array(
						'' => array('txt' => 'None', 'img' => ''),
					),
			),
		'list_state' => array(
								'values' => array(
						0 => array('txt' => 'None', 'img' => 'blank'),
						1 => array('txt' => 'AU New South Wales', 'img' => 'au_new_south_wales'),
						2 => array('txt' => 'AU New South Wales2', 'img' => 'au_new_south_wales2'),
						3 => array('txt' => 'AU Aboriginal', 'img' => 'au_aboriginal'),
						4 => array('txt' => 'AU Capitol Territory', 'img' => 'au_capitol_territory'),
						5 => array('txt' => 'AU Christmas Island', 'img' => 'au_christmas_island'),
						6 => array('txt' => 'AU Lord Howe Island', 'img' => 'au_lord_howe_island'),
						7 => array('txt' => 'AU Norfolk Island', 'img' => 'au_norfolk_island'),
						8 => array('txt' => 'AU Northern Territory', 'img' => 'au_northern_territory'),
						9 => array('txt' => 'AU Queensland', 'img' => 'au_queensland'),
						10 => array('txt' => 'AU Queensland2', 'img' => 'au_queensland2'),
						11 => array('txt' => 'AU South Australia', 'img' => 'au_south_australia'),
						12 => array('txt' => 'AU South Australia2', 'img' => 'au_south_australia2'),
						13 => array('txt' => 'AU Tasmania', 'img' => 'au_tasmania'),
						14 => array('txt' => 'AU Tasmania2', 'img' => 'au_tasmania2'),
						15 => array('txt' => 'AU Torres Strait', 'img' => 'au_torres_strait'),
						16 => array('txt' => 'AU Victoria', 'img' => 'au_victoria'),
						17 => array('txt' => 'AU Victoria2', 'img' => 'au_victoria2'),
						18 => array('txt' => 'AU West Australia', 'img' => 'au_west_australia'),
						19 => array('txt' => 'AU West Australia2', 'img' => 'au_west_australia2'),
						20 => array('txt' => 'BE Antwerp', 'img' => 'be_antwerp'),
						21 => array('txt' => 'BE Henegouwen', 'img' => 'be_henegouwen'),
						22 => array('txt' => 'BE Limbourg', 'img' => 'be_limbourg'),
						23 => array('txt' => 'BE Luik', 'img' => 'be_luik'),
						24 => array('txt' => 'BE Luxemburg1', 'img' => 'be_luxemburg'),
						25 => array('txt' => 'BE Namen', 'img' => 'be_namen'),
						26 => array('txt' => 'BE Oost-Vlaanderen', 'img' => 'be_oost_vlaanderen'),
						27 => array('txt' => 'BE Vlaams-Brabant', 'img' => 'be_vlaams_brabant'),
						28 => array('txt' => 'BE Vlaanderen', 'img' => 'be_vlaanderen'),
						29 => array('txt' => 'BE Waals-Brabant', 'img' => 'be_waals_brabant'),
						30 => array('txt' => 'BE West-Vlaanderen', 'img' => 'be_west_vlaanderen'),
						31 => array('txt' => 'CA Alberta', 'img' => 'ca_alberta'),
						32 => array('txt' => 'CA British Columbia', 'img' => 'ca_british_columbia'),
						33 => array('txt' => 'CA Labrador', 'img' => 'ca_labrador'),
						34 => array('txt' => 'CA Manitoba', 'img' => 'ca_manitoba'),
						35 => array('txt' => 'CA New Brunswick', 'img' => 'ca_new_brunswick'),
						36 => array('txt' => 'CA New Foundland', 'img' => 'ca_new_foundland'),
						37 => array('txt' => 'CA Northwest Territory', 'img' => 'ca_northwest_territory'),
						38 => array('txt' => 'CA Nova Scotia', 'img' => 'ca_nova_scotia'),
						39 => array('txt' => 'CA Nunavut', 'img' => 'ca_nunavut'),
						40 => array('txt' => 'CA Ontario', 'img' => 'ca_ontario'),
						41 => array('txt' => 'CA Prince Edward Island', 'img' => 'ca_prince_edward_island'),
						42 => array('txt' => 'CA Quebec', 'img' => 'ca_quebec'),
						43 => array('txt' => 'CA Saskatchewan', 'img' => 'ca_saskatchewan'),
						44 => array('txt' => 'CA Yukon', 'img' => 'ca_yukon'),
						46 => array('txt' => 'DE Baden Wurttemberg', 'img' => 'de_baden'),
						47 => array('txt' => 'DE Bavaria', 'img' => 'de_bavaria'),
						48 => array('txt' => 'DE Berlin', 'img' => 'de_berlin'),
						49 => array('txt' => 'DE Brandenburg', 'img' => 'de_brandenburg'),
						50 => array('txt' => 'DE Bremen', 'img' => 'de_bremen'),
						51 => array('txt' => 'DE Hamburg', 'img' => 'de_hamburg'),
						52 => array('txt' => 'DE Hesse', 'img' => 'de_hesse'),
						53 => array('txt' => 'DE Lower Saxony', 'img' => 'de_lower_saxony'),
						54 => array('txt' => 'DE Mecklenburg', 'img' => 'de_mecklenburg'),
						55 => array('txt' => 'DE North Rhine', 'img' => 'de_north_rhine'),
						56 => array('txt' => 'DE Rhineland', 'img' => 'de_rhineland'),
						57 => array('txt' => 'DE Saar', 'img' => 'de_saar'),
						58 => array('txt' => 'DE Saxony', 'img' => 'de_saxony'),
						59 => array('txt' => 'DE Saxony Anhalt', 'img' => 'de_saxony_anhalt'),
						60 => array('txt' => 'DE Schleswig', 'img' => 'de_schleswig'),
						61 => array('txt' => 'DE Thuringia', 'img' => 'de_thuringia'),
						45 => array('txt' => 'European Union', 'img' => 'european_union'),
						62 => array('txt' => 'NL Drenthe', 'img' => 'nl_drenthe'),
						63 => array('txt' => 'NL Flevoland', 'img' => 'nl_flevoland'),
						64 => array('txt' => 'NL Frysln', 'img'=> 'nl_fryslan'),
						65 => array('txt' => 'NL Gelderland', 'img' => 'nl_gelderland'),
						66 => array('txt' => 'NL Groningen', 'img' => 'nl_groningen'),
						67 => array('txt' => 'NL Limburg', 'img' => 'nl_limburg.gif'),
						68 => array('txt' => 'NL Noord Brabant', 'img' => 'nl_noord_brabant'),
						69 => array('txt' => 'NL Noord Holland', 'img' => 'nl_noord_holland'),
						70 => array('txt' => 'NL Overijssel', 'img' => 'nl_overijssel'),
						71 => array('txt' => 'NL Zuid Holland', 'img' => 'nl_zuid_holland'),
						72 => array('txt' => 'NL Utrecht', 'img' => 'nl_utrecht'),
						73 => array('txt' => 'NL Zeeland', 'img' => 'nl_zeeland'),
						74 => array('txt' => 'NO Agdenes', 'img' => 'no_agdenes'),
						75 => array('txt' => 'NO Agder', 'img' => 'no_agder'),
						76 => array('txt' => 'NO Akershus', 'img' => 'no_akershus'),
						77 => array('txt' => 'NO Bergen', 'img' => 'no_bergen'),
						78 => array('txt' => 'NO Bodoe', 'img' => 'no_bodoe'),
						79 => array('txt' => 'NO Buskerud', 'img' => 'no_buskerud'),
						80 => array('txt' => 'NO Finnmark', 'img' => 'no_finnmark'),
						81 => array('txt' => 'NO Hadsel', 'img' => 'no_hadsel'),
						82 => array('txt' => 'NO Hedmark', 'img' => 'no_hedmark'),
						83 => array('txt' => 'NO Hordaland', 'img' => 'no_hordaland'),
						84 => array('txt' => 'NO More Romsdal', 'img' => 'no_more_romsdal'),
						85 => array('txt' => 'NO Nissedal', 'img' => 'no_nissedal'),
						86 => array('txt' => 'NO Nordland', 'img' => 'no_nordland'),
						87 => array('txt' => 'NO North Norway', 'img' => 'no_north_norway'),
						88 => array('txt' => 'NO North Trondelag', 'img' => 'no_north_trondelag'),
						89 => array('txt' => 'NO Oppland', 'img' => 'no_oppland'),
						91 => array('txt' => 'NO Orskog', 'img' => 'no_orskog'),
						92 => array('txt' => 'NO Oslo', 'img' => 'no_oslo'),
						93 => array('txt' => 'NO Oslo2', 'img' => 'no_oslo2'),
						94 => array('txt' => 'NO Ostfold', 'img' => 'no_ostfold'),
						95 => array('txt' => 'NO Rogaland', 'img' => 'no_rogaland'),
						96 => array('txt' => 'NO Salangen', 'img' => 'no_salangen'),
						97 => array('txt' => 'NO Sami People', 'img' => 'no_sami_people'),
						98 => array('txt' => 'NO Sogn Fjordane', 'img' => 'no_sogn_fjordane'),
						99 => array('txt' => 'NO Sortland', 'img' => 'no_sortland'),
						100 => array('txt' => 'NO Stord', 'img' => 'no_stord'),
						101 => array('txt' => 'NO Telemark', 'img' => 'no_telemark'),
						102 => array('txt' => 'NO Troms', 'img' => 'no_troms'),
						103 => array('txt' => 'NO Trondelag', 'img' => 'no_trondelag'),
						104 => array('txt' => 'NO Trondheim', 'img' => 'no_trondheim'),
						105 => array('txt' => 'NO Vest Agder', 'img' => 'no_vest_agder'),
						106 => array('txt' => 'NO Vest Norway', 'img' => 'no_vest_norway'),
						107 => array('txt' => 'NO Vestfold', 'img' => 'no_vestfold'),
						108 => array('txt' => 'SE Fishing Flag', 'img' => 'se_fishing_flag'),
						109 => array('txt' => 'SE Goetaland', 'img' => 'se_goetaland'),
						110 => array('txt' => 'SE Haelsingland', 'img' => 'se_haelsingland'),
						111 => array('txt' => 'SE Harjedalen', 'img' => 'se_harjedalen'),
						112 => array('txt' => 'SE Jamtland', 'img' => 'se_jamtland'),
						113 => array('txt' => 'SE Norrland', 'img' => 'se_norrland'),
						114 => array('txt' => 'SE Oelaand', 'img' => 'se_oelaand'),
						115 => array('txt' => 'SE Ostergotland', 'img' => 'se_ostergotland'),
						116 => array('txt' => 'SE Sigtun', 'img' => 'se_sigtun'),
						117 => array('txt' => 'SE Skane', 'img' => 'se_skane'),
						118 => array('txt' => 'SE Smaaland', 'img' => 'se_smaaland'),
						119 => array('txt' => 'SE Stockholm', 'img' => 'se_stockholm'),
						120 => array('txt' => 'SE West Sweden', 'img' => 'se_west_sweden'),
						121 => array('txt' => 'UK England', 'img' => 'uk_england'),
						122 => array('txt' => 'UK Scotland', 'img' => 'uk_scotland'),
						123 => array('txt' => 'UK Wales', 'img' => 'uk_wales'),
						124 => array('txt' => 'UK Bedfordshire', 'img' => 'uk_bedfordshire'),
						125 => array('txt' => 'UK Cambridgeshire', 'img' => 'uk_cambridgeshire'),
						126 => array('txt' => 'UK City of London', 'img' => 'uk_city_of_london'),
						127 => array('txt' => 'UK Cornwall', 'img' => 'uk_cornwall'),
						128 => array('txt' => 'UK Crest', 'img' => 'uk_crest'),
						129 => array('txt' => 'UK Devon', 'img' => 'uk_devon'),
						130 => array('txt' => 'UK Durham City', 'img' => 'uk_durham_city'),
						131 => array('txt' => 'UK Essex', 'img' => 'uk_essex'),
						132 => array('txt' => 'UK Gibraltar', 'img' => 'uk_gibraltar'),
						133 => array('txt' => 'UK Guernsey', 'img' => 'uk_guernsey'),
						134 => array('txt' => 'UK Hay on Wye', 'img' => 'uk_hay_on_wye'),
						135 => array('txt' => 'UK Indian Ocean', 'img' => 'uk_indianocean'),
						136 => array('txt' => 'UK Isle of Man', 'img' => 'uk_isle_of_man'),
						137 => array('txt' => 'UK Isle of Wight', 'img' => 'uk_isle_of_wight'),
						138 => array('txt' => 'UK Jersey', 'img' => 'uk_jersey'),
						139 => array('txt' => 'UK Lincoln', 'img' => 'uk_lincoln'),
						140 => array('txt' => 'UK Mercia', 'img' => 'uk_mercia'),
						141 => array('txt' => 'UK Montserrat', 'img' => 'uk_montserrat'),
						142 => array('txt' => 'UK Northumberland', 'img' => 'uk_northumberland'),
						143 => array('txt' => 'UK Orkney', 'img' => 'uk_orkney'),
						144 => array('txt' => 'UK Pembrokeshire', 'img' => 'uk_pembrokeshire'),
						145 => array('txt' => 'UK Pitcairn', 'img' => 'uk_pitcairn'),
						146 => array('txt' => 'UK Shetland', 'img' => 'uk_shetland'),
						147 => array('txt' => 'UK St Albans', 'img' => 'uk_st_albans'),
						148 => array('txt' => 'UK St Helene', 'img' => 'uk_st_helene'),
						149 => array('txt' => 'UK Staffordshire', 'img' => 'uk_staffordshire'),
						150 => array('txt' => 'UK Turks Caicos', 'img' => 'uk_turks_caicos'),
						151 => array('txt' => 'UK Wessex', 'img' => 'uk_wessex'),
						152 => array('txt' => 'UK Yorkshire', 'img' => 'uk_yorkshire'),
						153 => array('txt' => 'US Alabama', 'img' => 'us_alabama'),
						154 => array('txt' => 'US Alaska', 'img' => 'us_alaska'),
						155 => array('txt' => 'US Arizona', 'img' => 'us_arizona'),
						156 => array('txt' => 'US Arkansas', 'img' => 'us_arkansas'),
						157 => array('txt' => 'US California', 'img' => 'us_california'),
						158 => array('txt' => 'US Colorado', 'img' => 'us_colorado'),
						159 => array('txt' => 'US Connecticut', 'img' => 'us_connecticut'),
						160 => array('txt' => 'US Delaware', 'img' => 'us_delaware'),
						161 => array('txt' => 'US District of Columbia', 'img' => 'us_district_of_columbia'),
						162 => array('txt' => 'US Florida', 'img' => 'us_florida'),
						163 => array('txt' => 'US Georgia', 'img' => 'us_georgia'),
						164 => array('txt' => 'US Hawaii', 'img' => 'us_hawaii'),
						165 => array('txt' => 'US Idaho', 'img' => 'us_idaho'),
						166 => array('txt' => 'US Illinois', 'img' => 'us_illinois'),
						167 => array('txt' => 'US Indiana', 'img' => 'us_indiana'),
						168 => array('txt' => 'US Iowa', 'img' => 'us_iowa'),
						169 => array('txt' => 'US Kansas', 'img' => 'us_kansas'),
						170 => array('txt' => 'US Kentucky', 'img' => 'us_kentucky'),
						171 => array('txt' => 'US Louisiana', 'img' => 'us_louisiana'),
						172 => array('txt' => 'US Maine', 'img' => 'us_maine'),
						173 => array('txt' => 'US Maryland', 'img' => 'us_maryland'),
						174 => array('txt' => 'US Massachusetts', 'img' => 'us_massachusetts'),
						175 => array('txt' => 'US Michigan', 'img' => 'us_michigan'),
						176 => array('txt' => 'US Minnesota', 'img' => 'us_minnesota'),
						177 => array('txt' => 'US Mississippi', 'img' => 'us_mississippi'),
						178 => array('txt' => 'US Missouri', 'img' => 'us_missouri'),
						179 => array('txt' => 'US Montana', 'img' => 'us_montana'),
						180 => array('txt' => 'US Nebraska', 'img' => 'us_nebraska'),
						181 => array('txt' => 'US Nevada', 'img' => 'us_nevada'),
						182 => array('txt' => 'US New Hampshire', 'img' => 'us_new_hampshire'),
						183 => array('txt' => 'US New Jersey', 'img' => 'us_new_jersey'),
						184 => array('txt' => 'US New Mexico', 'img' => 'us_new_mexico'),
						185 => array('txt' => 'US New York', 'img' => 'us_new_york'),
						186 => array('txt' => 'US North Carolina', 'img' => 'us_north_carolina'),
						187 => array('txt' => 'US North Dakota', 'img' => 'us_north_dakota'),
						188 => array('txt' => 'US Ohio', 'img' => 'us_ohio'),
						189 => array('txt' => 'US Oklahoma', 'img' => 'us_oklahoma'),
						190 => array('txt' => 'US Oregon', 'img' => 'us_oregon'),
						191 => array('txt' => 'US Pennsylvania', 'img' => 'us_pennsylvania'),
						192 => array('txt' => 'US Rhode Island', 'img' => 'us_rhode_island'),
						193 => array('txt' => 'US South Carolina', 'img' => 'us_south_carolina'),
						194 => array('txt' => 'US South Dakota', 'img' => 'us_south_dakota'),
						195 => array('txt' => 'US Tennessee', 'img' => 'us_tennessee'),
						196 => array('txt' => 'US Texas', 'img' => 'us_texas'),
						197 => array('txt' => 'US Utah', 'img' => 'us_utah'),
						198 => array('txt' => 'US Vermont', 'img' => 'us_vermont'),
						199 => array('txt' => 'US Virgin Islands', 'img' => 'us_virgin_islands'),
						200 => array('txt' => 'US Virginia', 'img' => 'us_virginia'),
						201 => array('txt' => 'US Washington', 'img' => 'us_washington'),
						202 => array('txt' => 'US West Virginia', 'img' => 'us_west_virginia'),
						203 => array('txt' => 'US Wisconsin', 'img' => 'us_wisconsin'),
						204 => array('txt' => 'US Wyoming', 'img' => 'us_wyoming'),
					),
			),
		'list_styles' => array(
						'table' => array(
			'main'	=> 'THEMES_TABLE',
			'key'	=> '[THEMES_TABLE].themes_id',
			'txt'	=> '[THEMES_TABLE].style_name',
			'img'	=> '',
				),
			),
		'list_timezones' => array(
				'func' => 'get_timezones_list',
							),
		'list_yes_no' => array(
								'values' => array(
						1 => array('txt' => 'Yes', 'img' => ''),
						0 => array('txt' => 'No', 'img' => ''),
					),
			),
		'list_yes_no_friend' => array(
								'values' => array(
						1 => array('txt' => 'Yes', 'img' => ''),
						0 => array('txt' => 'No', 'img' => ''),
						2 => array('txt' => 'Friend_only', 'img' => ''),
					),
			),
		'list_sun_mon' => array(
								'values' => array(
						1 => array('txt' => 'Monday', 'img' => ''),
						0 => array('txt' => 'Sunday', 'img' => ''),
					),
			),
	);

//--------------------------------------------------------------------------------------------------
//
// $classes_fields array
//
//		key = name of the class,
//
//			config_field	: the config table field set by the admin to restrict the class display to everybody
//			admin_field		: the users table field set by the admin to restrict the class display to a particular user,
//			user_field		: the users table field set by the user (preferences) to restrict the class display,
//			sql_def			: sql definition of the condition field
//
//--------------------------------------------------------------------------------------------------
$classes_fields = array(
		'email' => array(
		'config_field'	=> 'user_viewemail',
		'admin_field'	=> 'user_allow_email',
		'user_field'	=> 'user_viewemail',
		'sql_def'		=> '
				[USERS].user_id = [view.user_id] OR ( ( [BUDDY_MY].buddy_ignore <> 1 OR 
				[BUDDY_MY].buddy_ignore IS NULL ) AND ( [board.user_viewemail] <> 0 OR 
				[board.user_viewemail_over] <> 1 ) AND [USERS].user_allow_email = 1 AND 
				([BUDDY_OF].buddy_visible = 1 OR ( [USERS].user_viewemail = 1 OR 
				([board.user_viewemail] = 1 AND [board.user_viewemail_over] = 1) ) OR 
				( [BUDDY_OF].buddy_ignore = 0 AND ( [USERS].user_viewemail = 2 OR 
				([board.user_viewemail] = 2 AND [board.user_viewemail_over] = 1) ) ) ) )',
	),
		'generic' => array(
		'config_field'	=> '',
		'admin_field'	=> '',
		'user_field'	=> '',
		'sql_def'		=> '',
	),
		'pm' => array(
		'config_field'	=> 'user_viewpm',
		'admin_field'	=> 'user_allow_pm',
		'user_field'	=> 'user_viewpm',
		'sql_def'		=> '
				[USERS].user_id = [view.user_id] OR ( ( [BUDDY_MY].buddy_ignore <> 1 OR 
				[BUDDY_MY].buddy_ignore IS NULL ) AND ( [board.user_viewpm] <> 0 OR 
				[board.user_viewpm_over] <> 1 ) AND [USERS].user_allow_pm = 1 AND 
				( [BUDDY_OF].buddy_visible = 1 OR ( [USERS].user_viewpm = 1 OR 
				([board.user_viewpm] = 1 AND [board.user_viewpm_over] = 1) ) OR 
				( [BUDDY_OF].buddy_ignore = 0 AND ( [USERS].user_viewpm = 2 OR 
				([board.user_viewpm] = 2 AND [board.user_viewpm_over] = 1) ) ) ) )',
	),
		'real' => array(
		'config_field'	=> 'user_viewreal',
		'admin_field'	=> 'user_allow_real',
		'user_field'	=> 'user_viewreal',
		'sql_def'		=> '
				[USERS].user_id = [view.user_id] OR ( ( [BUDDY_MY].buddy_ignore <> 1 OR 
				[BUDDY_MY].buddy_ignore IS NULL ) AND ( [board.user_viewreal] <> 0 OR 
				[board.user_viewreal_over] <> 1 ) AND [USERS].user_allow_real = 1 AND 
				( [BUDDY_OF].buddy_visible = 1 OR ( [USERS].user_viewreal = 1 OR 
				([board.user_viewreal] = 1 AND [board.user_viewreal_over] = 1) ) OR 
				( [BUDDY_OF].buddy_ignore = 0 AND ( [USERS].user_viewreal = 2 OR 
				([board.user_viewreal] = 2 AND [board.user_viewreal_over] = 1) ) ) ) )',
	),
		'viewonline' => array(
		'config_field'	=> 'user_allow_viewonline',
		'admin_field'	=> '',
		'user_field'	=> 'user_allow_viewonline',
		'sql_def'		=> '
				[USERS].user_id = [view.user_id] OR ( ( [BUDDY_MY].buddy_ignore <> 1 OR 
				[BUDDY_MY].buddy_ignore IS NULL ) AND ( [board.user_allow_viewonline] <> 0 OR 
				[board.user_allow_viewonline_over] <> 1 ) AND ( [BUDDY_OF].buddy_visible = 1 OR 
				( [USERS].user_allow_viewonline = 1 OR ([board.user_allow_viewonline] = 1 AND 
				[board.user_allow_viewonline_over] = 1) ) OR ( [BUDDY_OF].buddy_ignore = 0 AND 
				( [USERS].user_allow_viewonline = 2 OR ([board.user_allow_viewonline] = 2 AND
				 [board.user_allow_viewonline_over] = 1) ) ) ) )',
	),
		'webdisplay' => array(
		'config_field'	=> 'user_viewwebsite',
		'admin_field'	=> 'user_allow_website',
		'user_field'	=> 'user_viewwebsite',
		'sql_def'		=> '
				[USERS].user_id = [view.user_id] OR ( ( [BUDDY_MY].buddy_ignore <> 1 OR
				 [BUDDY_MY].buddy_ignore IS NULL ) AND ( [board.user_viewwebsite] <> 0 OR 
				 [board.user_viewwebsite_over] <> 1 ) AND [USERS].user_allow_website = 1 AND ( 
				 [BUDDY_OF].buddy_visible = 1 OR ( [USERS].user_viewwebsite = 1 OR 
				 ([board.user_viewwebsite] = 1 AND [board.user_viewwebsite_over] = 1) ) OR 
				 ( [BUDDY_OF].buddy_ignore = 0 AND ( [USERS].user_viewwebsite = 2 OR 
				 ([board.user_viewwebsite] = 2 AND [board.user_viewwebsite_over] = 1) ) ) ) )',
	),
		'messengers' => array(
		'config_field'	=> 'user_viewmessenger',
		'admin_field'	=> 'user_allow_messenger',
		'user_field'	=> 'user_viewmessenger',
		'sql_def'		=> '
				[USERS].user_id = [view.user_id] OR ( ( [BUDDY_MY].buddy_ignore <> 1 OR 
				[BUDDY_MY].buddy_ignore IS NULL ) AND ( [board.user_viewmessenger] <> 0 OR 
				[board.user_viewmessenger_over] <> 1 ) AND [USERS].user_allow_messenger = 1 AND 
				( [BUDDY_OF].buddy_visible = 1 OR ( [USERS].user_viewmessenger = 1 OR 
				([board.user_viewmessenger] = 1 AND [board.user_viewmessenger_over] = 1) ) OR 
				( [BUDDY_OF].buddy_ignore = 0 AND ( [USERS].user_viewmessenger = 2 OR 
				([board.user_viewmessenger] = 2 AND [board.user_viewmessenger_over] = 1) ) ) ) )',
	),
		'password' => array(
		'config_field'	=> 'user_password',
		'admin_field'	=> '',
		'user_field'	=> 'user_password',
		'sql_def'		=> '0=1',
	),
	);

//--------------------------------------------------------------------------------------------------
//
// $user_fields array
//
//		key = name of the field,
//
//			field_name  : Field name//			lang_key    : Legend of the field//			explain     : Explanation of the field//			image       : Image//			title       : Image title//			class       : Class//			type        : Type//			link        : Link//			dsp_func    : Display function//			leg         : Display the legend//			txt         : Display the text value//			img         : Display the image value//			crlf        : Text to next line//			lnk         : Use the link//			style       : Span display//			user_only   : Not a config value//			system      : System field//			required    : Required field//			visibility  : Show Visibility//			get_mode    : Get mode//			get_func    : Get function//			chk_func    : Check function//			default     : Default value//			values      : Values list//			inputstyle  : Input Template style//			auth        : Auth level//			ind         : Option address//			dft         : Checked by default//			rqd         : Force the selection//			hidden      : Add the field as hidden//			sql_def     : SQL definition//
//--------------------------------------------------------------------------------------------------
$user_fields = array(
		
	// email informations
		'user_email' => array(
				'lang_key'     => 'Email_address',
				'class'        => 'email',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_user_email',
				'auth'         => USER,
				'required'     => true,
				'visibility'   => true,
				'get_func'     => 'mods_get_email',
				'chk_func'     => 'mods_check_email',
				'ind'          => '4',
			),
		
	// generic informations
		'board_fdow' => array(
				'lang_key'     => 'FDOW',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'auth'         => BOARD_ADMIN,
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_sun_mon',
			),
		'forum_rules' => array(
				'lang_key'     => 'Forum_rules',
				'class'        => 'generic',
				'type'         => 'INT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
		'icon_per_row' => array(
				'lang_key'     => 'Icons_per_row',
				'explain'			 => 'Icons_per_row_explain',
				'class'        => 'generic',
				'type'				 => 'TINYINT',
				'auth'         => BOARD_ADMIN,
			),
		'mini_cal_auth' => array(
				'lang_key'     => 'mini_cal_auth',
				'explain'      => 'mini_cal_auth_explain',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'auth'         => BOARD_ADMIN,
				'get_mode'     => 'LIST_DROP',
				'values'       => 'list_auth',
			),
		'mini_cal_calendar_version' => array(
				'lang_key'     => 'mini_cal_calendar_version',
				'explain'      => 'mini_cal_calendar_version_explain',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'auth'         => BOARD_ADMIN,
				'get_mode'     => 'LIST_DROP',
				'values'       => 'list_cal_versions',
			),
		'mini_cal_date_search' => array(
				'lang_key'     => 'mini_cal_date_search',
				'explain'      => 'mini_cal_date_search_explain',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'auth'         => BOARD_ADMIN,
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_cal_search',
			),
		'mini_cal_days_ahead' => array(
				'lang_key'     => 'mini_cal_days_ahead',
				'explain'      => 'mini_cal_days_ahead_explain',
				'class'        => 'generic',
				'type'         => 'MEDIUMINT',
				'auth'         => BOARD_ADMIN,
			),
		'mini_cal_limit' => array(
				'lang_key'     => 'mini_cal_limit',
				'explain'      => 'mini_cal_limit_explain',
				'class'        => 'generic',
				'type'         => 'MEDIUMINT',
				'auth'         => BOARD_ADMIN,
			),
		'mini_cal_link_class' => array(
				'lang_key'     => 'mini_cal_link_class',
				'explain'      => 'mini_cal_link_class_explain',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'auth'         => BOARD_ADMIN,
			),
		'mini_cal_today_class' => array(
				'lang_key'     => 'mini_cal_today_class',
				'explain'      => 'mini_cal_today_class_explain',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'auth'         => BOARD_ADMIN,
			),
		'phpBBSecurity_answer' => array(
				'lang_key'     => 'PS_security_answer',
				'explain'      => 'PS_security_answer_exp',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'required'     => true,
				'get_func'     => 'mods_get_phpBBSecurity_answer',
				'chk_func'     => 'mods_check_phpBBSecurity_answer',
				'auth'         => USER,
			),
		'phpBBSecurity_question' => array(
				'lang_key'     => 'PS_security_question',
				'explain'      => 'PS_security_question_exp',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'required'     => true,
				'get_func'     => 'mods_get_phpBBSecurity_question',
				'chk_func'     => 'mods_check_phpBBSecurity_question',
				'auth'         => USER,
			),
		'robotic_register' => array(
				'lang_key'     => 'anti_robotic',
				'explain'      => 'anti_robotic_explain',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'auth'         => BOARD_ADMIN,
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
		'summer_time' => array(
				'lang_key'     => 'summer_time_set',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'auth'         => BOARD_ADMIN,
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
		'summer_time_auto' => array(
				'lang_key'     => 'summer_time_auto_set',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'auth'         => BOARD_ADMIN,
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
		'user_active' => array(
				'lang_key'     => 'User_status',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
				'auth'         => ADMIN,
			),
		'user_allow_email' => array(
				'lang_key'     => 'User_allow_email',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
				'auth'         => ADMIN,
			),
		'user_allow_messenger' => array(
				'lang_key'     => 'User_allow_messenger',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'auth'         => ADMIN,
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
		'user_allow_pm' => array(
				'lang_key'     => 'User_allow_pm',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'auth'         => ADMIN,
				'values'       => 'list_yes_no',
			),
		'user_allow_real' => array(
				'lang_key'     => 'User_allow_real',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
				'auth'         => ADMIN,
			),
		'user_allow_viewonline' => array(
				'lang_key'     => 'View_user',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no_friend',
			),
		'user_allow_website' => array(
				'lang_key'     => 'User_allow_website',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'auth'         => ADMIN,
				'values'       => 'list_yes_no',
			),
			'user_allowavatar' => array(
				'lang_key'     => 'User_allowavatar',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'auth'         => ADMIN,
				'values'       => 'list_yes_no',
			),
			'user_allowphoto' => array(
				'lang_key'     => 'User_allowphoto',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'auth'         => ADMIN,
				'values'       => 'list_yes_no',
			),
			'user_viewphoto' => array(
				'lang_key'     => 'Public_view_photo',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_photo' => array(
				'lang_key'     => 'Photo',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_photo',
			),
			'user_allowbbcode' => array(
				'lang_key'     => 'Always_bbcode',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_allowhtml' => array(
				'lang_key'     => 'Always_html',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
		'user_allowsignature' => array(
				'lang_key'     => 'User_allow_sig',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'auth'         => ADMIN,
				'values'       => 'list_sig',
			),
			'user_allowsmile' => array(
				'lang_key'     => 'Always_smile',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_attachsig' => array(
				'lang_key'     => 'Always_add_sig',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_buddy_friend_display' => array(
				'lang_key'     => 'Buddy_friend_display',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_buddy_friend_of_display' => array(
				'lang_key'     => 'Buddy_friend_of_display',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_buddy_ignore_display' => array(
				'lang_key'     => 'Buddy_ignore_display',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_buddy_ignored_by_display' => array(
				'lang_key'     => 'Buddy_ignored_by_display',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_cashpr' => array(
				'lang_key'     => 'Cash Mod',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_cashpr',
			),
			'user_cashtp' => array(
				'lang_key'     => 'Cash Mod',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_cashtp',
			),
			'user_country' => array(
				'lang_key'     => 'profil_country',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_country',
				'required'     => true,
				'visibility'   => true,
				'get_mode'     => 'LIST_DROP',
				'values'       => 'list_country',
				'auth'         => USER,
			),
			'user_custom_rank' => array(
				'lang_key'     => 'User_custom_rank',
				'class'        => 'generic',
				'type'         => 'MEDIUMINT',
				'dsp_func'     => 'pcp_output_rank_title',
				'get_mode'     => 'LIST_DROP',
				'values'       => 'list_special_ranks',
				'auth'         => USER,
				'sql_def'      => '[CUSTOM_RANKS].rank_id',
			),
			'user_extra' => array(
				'lang_key'     => 'Extra_priv_explain',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'auth'         => ADMIN,
				'values'       => 'list_yes_no',
			),
			'user_friend' => array(
				'lang_key'     => 'Friend_of',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'sql_def'      => '(CASE WHEN [BUDDY_OF].buddy_ignore = 0 THEN 1 ELSE 0 END)',
				'hidden'       => true,
			),
			'user_group_id' => array(
				'lang_key'     => 'AGCM_user_color',
				'explain'      => 'AGCM_user_color_explain',
				'class'        => 'generic',
				'type'         => 'MEDIUMINT',
				'visibility'   => true,
				'get_mode'     => 'LIST_DROP',
				'values'       => 'list_groups',
				'auth'         => USER,
			),
			'user_groups' => array(
				'lang_key'     => 'Usergroups',
				'class'        => 'generic',
				'type'         => 'ADVANCED',
				'dsp_func'     => 'pcp_output_usergroups',
			),
			'user_ignore' => array(
				'lang_key'     => 'Ignore_by',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'sql_def'      => '(CASE WHEN [BUDDY_OF].buddy_ignore = 1 THEN 1 ELSE 0 END)',
				'hidden'       => true,
			),
			'user_my_friend' => array(
				'lang_key'     => 'Friend',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'sql_def'      => '(CASE WHEN [BUDDY_MY].buddy_ignore = 0 THEN 1 ELSE 0 END)',
				'dsp_func'     => 'pcp_output_my_friend',
				'ind'          => '27',
				'dft'          => true,
			),
			'user_my_ignore' => array(
				'lang_key'     => 'Ignore',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'sql_def'      => '(CASE WHEN [BUDDY_MY].buddy_ignore = 1 THEN 1 ELSE 0 END)',
				'dsp_func'     => 'pcp_output_my_ignore',
				'hidden'       => true,
			),
			'user_my_visible' => array(
				'lang_key'     => 'Always_visible',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'sql_def'      => '[BUDDY_MY].buddy_visible',
				'hidden'       => true,
			),
			'user_notify' => array(
				'lang_key'     => 'Always_notify',
				'explain'      => 'Always_notify_explain',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_notify_pm' => array(
				'lang_key'     => 'Notify_on_privmsg',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_popup_pm' => array(
				'lang_key'     => 'Popup_on_privmsg',
				'explain'      => 'Popup_on_privmsg_explain',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_privmsgs_per_page' => array(
				'lang_key'     => 'Privmsgs_per_page',
				'class'        => 'generic',
				'type'         => 'SMALLINT',
			),
			'user_rank' => array(
				'lang_key'     => 'Poster_rank',
				'class'        => 'generic',
				'type'         => 'MEDIUMINT',
				'dsp_func'     => 'pcp_output_rank_title',
				'get_mode'     => 'LIST_DROP',
				'values'       => 'list_special_ranks',
				'auth'         => ADMIN,
			),
			'user_rank_title' => array(
				'lang_key'     => 'Poster_rank',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_rank_title',
				'auth'         => USER,
				'ind'          => '27',
				'rqd'          => true,
				'sql_def'      => '[RANKS].rank_title',
			),
			'user_rules' => array(
				'lang_key'     => 'Forum_Rules',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'auth'         => USER,
				'required'     => true,
				'visibility'   => true,
				'inputstyle'   => 'rules',
				'get_func'     => 'mods_get_user_rules',
				'chk_func'     => 'mods_check_user_rules',
			),
			'user_session_page' => array(
				'lang_key'     => 'User_page',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_session_page',
			),
			'user_session_time' => array(
				'lang_key'     => 'User_session_time',
				'class'        => 'generic',
				'type'         => 'DATETIME',
				'dsp_func'     => 'pcp_output_session_time',
			),
			'user_setbm' => array(
				'lang_key'     => 'Always_set_bm',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_state' => array(
				'lang_key'     => 'profil_state',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_state',
				'visibility'   => true,
				'get_mode'     => 'LIST_DROP',
				'values'       => 'list_state',
				'auth'         => USER,
			),
			'user_topics_last_per_page' => array(
				'lang_key'     => 'PCP_topics_last_per_page',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'auth'         => USER,
			),
			'user_viewavatar' => array(
				'lang_key'     => 'Public_view_avatar',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_viewemail' => array(
				'lang_key'     => 'Public_view_email',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no_friend',
			),
			'user_viewimg' => array(
				'lang_key'     => 'Public_view_img',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_viewmessenger' => array(
				'lang_key'     => 'Public_view_messengers',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no_friend',
			),
			'user_viewpm' => array(
				'lang_key'     => 'Public_view_pm',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no_friend',
			),
			'user_viewreal' => array(
				'lang_key'     => 'Public_view_real_info',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no_friend',
			),
			'user_viewsig' => array(
				'lang_key'     => 'Public_view_sig',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_viewwebsite' => array(
				'lang_key'     => 'Public_view_website',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no_friend',
			),
			'user_visible' => array(
				'lang_key'     => 'Always_visible',
				'class'        => 'generic',
				'type'         => 'TINYINT',
				'sql_def'      => '[BUDDY_OF].buddy_visible',
				'ind'          => '43',
				'hidden'       => true,
			),
			'user_warnings' => array(
				'lang_key'     => 'user_warnings',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_warnings',
				'get_mode'     => 'TINYINT',
				'auth'         => ADMIN,
				'ind'          => '35',
			),
			'user_watched_topics_per_page' => array(
				'lang_key'     => 'Watched_topics_per_page',
				'type'         => 'SMALLINT',
				'class'        => 'generic',
			),
			'username' => array(
				'lang_key'     => 'Username',
				'class'        => 'generic',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_username',
				'ind'          => '2',
				'rqd'          => true,
				'auth'         => USER,
				'required'     => true,
				'visibility'   => true,
				'get_func'     => 'mods_get_username',
				'chk_func'     => 'mods_check_username',
			),

	// messengers informations
		'user_aim' => array(
				'lang_key'     => 'AIM',
				'class'        => 'messengers',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_aim',
				'visibility'   => true,
				'auth'         => USER,
				'ind'          => '6',
			),
			'user_icq' => array(
				'lang_key'     => 'ICQ',
				'class'        => 'messengers',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_icq',
				'ind'          => '5',
				'visibility'   => true,
			),
			'user_msnm' => array(
				'lang_key'     => 'MSNM',
				'class'        => 'messengers',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_msnm',
				'visibility'   => true,
				'ind'          => '8',
			),
			'user_skype' => array(
				'lang_key'     => 'SKYPE',
				'class'        => 'messengers',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_skype',
				'visibility'   => true,
				'ind'          => '7',
			),
			'user_yim' => array(
				'lang_key'     => 'YIM',
				'class'        => 'messengers',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_yim',
				'visibility'   => true,
				'ind'          => '9',
			),
		
	// password informations
		'user_password' => array(
				'lang_key'     => 'Password',
				'class'        => 'password',
				'type'         => 'VARCHAR',
				'auth'         => USER,
				'visibility'   => true,
				'get_func'     => 'mods_get_password',
				'chk_func'     => 'mods_check_password',
			),
		
	// pm informations
		'user_pm' => array(
				'lang_key'     => 'Private_Message',
				'image'        => 'icon_pm',
				'title'        => 'Send_private_message',
				'class'        => 'pm',
				'type'         => 'TINYINT',
				'sql_def'      => '1',
				'dsp_func'     => 'pcp_output_user_pm',
				'ind'          => '3',
			),
		
	// real informations
	'user_age' => array(
				'lang_key'     => 'Age',
				'class'        => 'real',
				'type'         => 'DATE',
				'dsp_func'     => 'pcp_output_age',
			),
	'user_birthday' => array(
				'lang_key'     => 'Birthday',
				'class'        => 'real',
				'type'         => 'BIRTHDAY',
				'ind'          => '17',
				'auth'         => USER,
				'required'     => true,
				'visibility'   => true,
				'get_func'     => 'mods_settings_get_birthday',
				'chk_func'     => 'mods_settings_check_birthday',
			),
			'user_cellular' => array(
				'lang_key'     => 'Cellular',
				'class'        => 'real',
				'type'         => 'VARCHAR',
				'visibility'   => true,
				'ind'          => '25',
			),
			'user_flag' => array(
				'lang_key'     => 'Country_Flag',
				'class'        => 'real',
				'type'         => 'FLAG',
				'dsp_func'     => 'pcp_output_flag',
				'ind'          => '32',
				'auth'         => USER,
				'visibility'   => true,
				'get_func'     => 'mods_settings_get_flags',
				'chk_func'     => 'mods_settings_check_flags',
			),
			'user_from' => array(
				'lang_key'     => 'Location',
				'class'        => 'real',
				'type'         => 'VARCHAR',
				'ind'          => '18',
				'auth'         => USER,
				'visibility'   => true,
			),
			'user_gender' => array(
				'lang_key'     => 'Gender',
				'class'        => 'real',
				'type'         => 'TINYINT',
				'dsp_func'     => 'pcp_output_gender',
				'ind'          => '16',
				'auth'         => USER,
				'visibility'   => true,
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_gender',
			),
			'user_holidays' => array(
				'lang_key'     => 'Holidays',
				'class'        => 'real',
				'type'         => 'TINYINT',
				'dsp_func'     => 'pcp_output_holidays',
				'ind'          => '31',
				'auth'         => USER,
				'visibility'   => true,
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_holidays',
			),
			'user_home_fax' => array(
				'lang_key'     => 'Home_fax',
				'class'        => 'real',
				'type'         => 'VARCHAR',
				'visibility'   => true,
				'ind'          => '22',
			),
			'user_home_phone' => array(
				'lang_key'     => 'Home_phone',
				'class'        => 'real',
				'type'         => 'VARCHAR',
				'visibility'   => true,
				'ind'          => '21',
			),
			'user_interests' => array(
				'lang_key'     => 'Interests',
				'class'        => 'real',
				'type'         => 'TEXT',
				'ind'          => '20',
				'auth'         => USER,
				'visibility'   => true,
			),
			'user_occ' => array(
				'lang_key'     => 'Occupation',
				'class'        => 'real',
				'type'         => 'VARCHAR',
				'ind'          => '19',
				'auth'         => USER,
				'visibility'   => true,
			),
			'user_pager' => array(
				'lang_key'     => 'Pager',
				'class'        => 'real',
				'type'         => 'VARCHAR',
				'visibility'   => true,
				'ind'          => '26',
			),
			'user_realname' => array(
				'lang_key'     => 'Realname',
				'class'        => 'real',
				'type'         => 'VARCHAR',
				'ind'          => '15',
				'auth'         => USER,
				'visibility'   => true,
			),
			'user_work_fax' => array(
				'lang_key'     => 'Work_fax',
				'class'        => 'real',
				'type'         => 'VARCHAR',
				'visibility'   => true,
				'ind'          => '24',
			),
			'user_work_phone' => array(
				'lang_key'     => 'Work_phone',
				'class'        => 'real',
				'type'         => 'VARCHAR',
				'visibility'   => true,
				'ind'          => '23',
			),
		
	// system informations
		'clear_security' => array(
				'lang_key'     => 'Clear_security',
				'explain'      => 'Clear_security_explain',
				'class'        => 'system',
				'type'         => 'TINYINT',
				'user_only'    => true,
				'system'       => true,
				'auth'         => ADMIN,
				'get_func'     => 'mods_get_security_option',
				'chk_func'     => 'mods_check_clear_security',
			),
		'delete_user' => array(
				'lang_key'     => 'User_delete',
				'explain'      => 'User_delete_explain',
				'class'        => 'system',
				'user_only'    => true,
				'system'       => true,
				'get_func'     => 'mods_settings_get_delete_user',
				'chk_func'     => 'mods_settings_check_delete_user',
				'auth'         => ADMIN,
				'type'         => 'VARCHAR',
			),
			'force_security' => array(
				'lang_key'     => 'Force_security',
				'explain'      => 'Force_security_explain',
				'class'        => 'system',
				'type'         => 'TINYINT',
				'user_only'    => true,
				'system'       => true,
				'auth'         => ADMIN,
				'get_func'     => 'mods_get_security_option',
				'chk_func'     => 'mods_check_force_security',
			),
			'reset_security' => array(
				'lang_key'     => 'Reset_security',
				'explain'      => 'Reset_security_explain',
				'class'        => 'system',
				'type'         => 'TINYINT',
				'user_only'    => true,
				'system'       => true,
				'auth'         => ADMIN,
				'get_func'     => 'mods_get_security_option',
				'chk_func'     => 'mods_check_reset_security',
			),
			'confirm_code' => array(
				'lang_key'     => 'Confirm_code',
				'explain'      => 'Confirm_code_explain',
				'class'        => 'system',
				'type'         => 'VARCHAR',
				'user_only'    => true,
				'system'       => true,
				'auth'         => GUEST_ONLY,
				'required'     => true,
				'visibility'   => true,
				'get_func'     => 'mods_get_confirm_code',
				'chk_func'     => 'mods_check_confirm_code',
			),
			'user_email_confirm' => array(
				'lang_key'     => 'profilcp_email_confirm',
				'class'        => 'system',
				'type'         => 'VARCHAR',
				'user_only'    => true,
				'system'       => true,
				'auth'         => USER,
				'required'     => true,
				'visibility'   => true,
				'get_func'     => 'mods_get_email_confirm',
				'chk_func'     => 'mods_check_email_confirm',
			),
			'user_password_confirm' => array(
				'lang_key'     => 'Confirm_password',
				'class'        => 'system',
				'type'         => 'VARCHAR',
				'user_only'    => true,
				'system'       => true,
				'auth'         => USER,
				'visibility'   => true,
				'get_func'     => 'mods_get_password',
				'chk_func'     => 'mods_check_password_confirm',
			),
			
	// viewonline informations
		'user_forums_stat' => array(
				'lang_key'     => 'Most_active_forum',
				'class'        => 'viewonline',
				'type'         => 'MEDIUMINT',
				'dsp_func'     => 'pcp_output_forums_stat',
			),
			'user_lastvisit' => array(
				'lang_key'     => 'Last_visit',
				'class'        => 'viewonline',
				'type'         => 'DATETIME',
				'ind'          => '10',
			),
			'user_online' => array(
				'lang_key'     => 'Online',
				'class'        => 'viewonline',
				'type'         => 'TINYINT',
				'sql_def'      => '(CASE WHEN [USERS].user_session_time >= ([time]-300) THEN 1 ELSE 0 END)',
				'dsp_func'     => 'pcp_output_user_online',
				'ind'          => '1',
				'rqd'          => true,
			),
			'user_posts' => array(
				'lang_key'     => 'Total_posts',
				'class'        => 'viewonline',
				'type'         => 'MEDIUMINT',
				'auth'         => ADMIN,
				'ind'          => '11',
				'dft'          => true,
			),
			'user_posts_stat' => array(
				'lang_key'     => 'User_posts',
				'class'        => 'viewonline',
				'type'         => 'MEDIUMINT',
				'dsp_func'     => 'pcp_output_posts_stat',
			),
			'user_regdate' => array(
				'lang_key'     => 'Joined',
				'class'        => 'viewonline',
				'type'         => 'DATE',
				'dsp_func'     => 'pcp_output_regdate',
				'ind'          => '9',
			),
			'user_topics_stat' => array(
				'lang_key'     => 'Most_active_topic',
				'class'        => 'viewonline',
				'type'         => 'MEDIUMINT',
				'dsp_func'     => 'pcp_output_topics_stat',
			),
		
	// webdisplay informations
		'user_album' => array(
				'lang_key'     => 'Gallery',
				'class'        => 'webdisplay',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_album',
			),
		'user_avatar' => array(
				'lang_key'     => 'Avatar',
				'class'        => 'webdisplay',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_avatar',
				'visibility'   => true,
			),
		'user_dateformat' => array(
				'lang_key'     => 'Date_format',
				'explain'      => 'Date_format_explain',
				'class'        => 'webdisplay',
				'type'         => 'VARCHAR',
				'get_func'     => 'mods_settings_get_datefmt',
				'chk_func'     => 'mods_settings_check_datefmt',
			),
		'user_fdow' => array(
				'lang_key'     => 'FDOW',
				'class'        => 'webdisplay',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_sun_mon',
			),
			'user_lang' => array(
				'lang_key'     => 'Board_lang',
				'class'        => 'webdisplay',
				'type'         => 'VARCHAR',
				'visibility'   => true,
				'get_mode'     => 'LIST_DROP',
				'values'       => 'list_langs',
				'ind'          => '13',
			),
			'user_sig' => array(
				'lang_key'     => 'Signature',
				'class'        => 'webdisplay',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_sig',
				'visibility'   => true,
			),
			'user_style' => array(
				'lang_key'     => 'Board_style',
				'class'        => 'webdisplay',
				'type'         => 'MEDIUMINT',
				'dsp_func'     => 'pcp_output_value_list',
				'get_mode'     => 'LIST_DROP',
				'values'       => 'list_styles',
			),
			'user_summer_time' => array(
				'lang_key'     => 'summer_time',
				'class'        => 'webdisplay',
				'type'         => 'TINYINT',
				'get_mode'     => 'LIST_RADIO',
				'values'       => 'list_yes_no',
			),
			'user_timezone' => array(
				'lang_key'     => 'Timezone',
				'class'        => 'webdisplay',
				'type'         => 'MEDIUMINT',
				'dsp_func'     => 'pcp_output_timezone',
				'visibility'   => true,
				'get_mode'     => 'LIST_DROP',
				'values'       => 'list_timezones',
				'ind'          => '12',
			),
			'user_website' => array(
				'lang_key'     => 'Website',
				'class'        => 'webdisplay',
				'type'         => 'VARCHAR',
				'dsp_func'     => 'pcp_output_website',
				'visibility'   => true,
				'auth'         => USER,
				'ind'          => '14',
			),
	);

?>